| IGLib 1.5 The IGLib base library for development of numerical, technical and business applications.

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Properties Events
Classes | Public Member Functions | Static Public Member Functions | Public Attributes | Protected Member Functions | Protected Attributes | Properties | Private Attributes | Static Private Attributes | List of all members
IG.Lib.WaitFileEventBase Class Reference

Base class for classes that provide blocking until a file or directory is created/removed. More...

Inheritance diagram for IG.Lib.WaitFileEventBase:
[legend]
Collaboration diagram for IG.Lib.WaitFileEventBase:
[legend]

## Classes
class | Example
| Class containing examples for waiting creation or removal of files and directories. More...

## Public Member Functions
void | TriggerConditionCheck ()
| Triggers condition check by pulsing the object on which Wait() successively waits. More...
override bool | Condition ()
| If not overridden, this condition always returns false. More...
override void | CancelOne ()
| Cancels the current waiting for the condition (if one is going on) and unblocks the thread on which waiting was called (possibly with some latency). More...
override void | CancelAll ()
| Cancel the current waiting for the condition on all threads. More...
void | WaitFirstEvent ()
| Blocks execution of the current thread until the first event is fired by the filesystem watcher. Enables raising events on the filesystem watcher, if not enabled. WARNING: This method is NOT thread safe. More...
virtual void | WaitEvents (int numEvents)
| Blocks execution of the current thread until the specified number of file system events are registered by the filesystem watcher. If the specified number of events is less than 1 then blicking is done ndefinitely (or until CancelWaiting() is called on the object from another thread). Enables raising events on the filesystem watcher, if not enabled. WARNING: This method is NOT thread safe. More...
override void | Wait ()
| Waits for condition to be fulfilled. More...
override string | ToString ()

## Static Public Member Functions
static void | ExampleWaitEvents (string fileOrDirectoryPath, int numEvents)
| Waits (blocks execution) until a given number of the specified file system events are registered. Basic information is printed for each event when it occurs. More...
static void | ExampleBlockCreateRemove (string filePath)
| Monitors the specified file and successively blocks until it is created and then until it is removed. This procedure is repeated twice. More...
static void | ExampleBlockCreateRemove (string filePath, int numSwitches)
| Monitors the specified file and successively blocks until it is created and then until it is removed. More...
static void | ExampleBlockCreateRemove (string filePath, int numSwitches, bool waitDirectory)
| Monitors the specified file and successively blocks until it is created and then until it is removed. More...
static void | TestSpeedBlockCreateRemove (string filePath)
| Test of speed of reaction of file/directory creation and removal blocking waits. A specified number of alternate creations and removals are perfomed in a parallel thread, with specified delay between them. In the main thread, blocking waits are performed waiting for creation/removal in an infinite loop, and it is counted how many events are captured and how many are missed. More...
static void | TestSpeedBlockCreateRemove (string filePath, int numSwitches, int sleepMs)
| Test of speed of reaction of file/directory creation and removal blocking waits. A specified number of alternate creations and removals are perfomed in a parallel thread, with specified delay between them. In the main thread, blocking waits are performed waiting for creation/removal in an infinite loop, and it is counted how many events are captured and how many are missed. More...
static void | TestSpeedBlockCreateRemove (string filePath, int numSwitches, int sleepMs, bool waitDirectory)
| Test of speed of reaction of file/directory creation and removal blocking waits. A specified number of alternate creations and removals are perfomed in a parallel thread, with specified delay between them. In the main thread, blocking waits are performed waiting for creation/removal in an infinite loop, and it is counted how many events are captured and how many are missed. More...

## Public Attributes
const System.IO.NotifyFilters | NotifyFiltersAll
| NotifyFilter enumeration that allows all kinds of events to be fired. More...

## Protected Member Functions
| WaitFileEventBase (string fileOrDirectoryPath)
virtual void | InitWaitFileEventBase (string fileOrDirectoryPath)
| Initializes the object appropriately. Overrride this method in derived classes! More...
string | EventToString (FileSystemEventArgs e)
virtual void | OnDeleted (object source, FileSystemEventArgs e)
| Handles events triggered when a file or directory is deleted. More...
virtual void | OnCreated (object source, FileSystemEventArgs e)
| Handles events triggered when a file or directory is created. More...
virtual void | OnChanged (object source, FileSystemEventArgs e)
| Handles events triggered when a file or directory is changed. More...
virtual void | OnRenamed (object source, RenamedEventArgs e)
| Handles events triggered when a file or directory is renamed. More...
void | OnError (object source, ErrorEventArgs e)
| Handles events triggered when an error occurs. More...
bool | ConditionInternal ()
| Wrapper around Condition() that enables control output to console. More...

## Protected Attributes
bool | _eventOccured = false
string | _fileOrDirectoryPath
| File or directory name. More...

## Properties
bool | PrintNotes`[get, set]`
| If true then various events and actions will be notified by console output (for testing purposes only!). More...
FileSystemWatcher | EventWatcher`[get]`
| Component that responds to file system events. More...
virtual bool | EventOccured`[get, set]`
| This flag is set by event handlers, and can be used by waiting procedures to check if the current event has been triggered by the EventWatcher installed on the other object (since registration of events of all other EventWatchers is done on the same thread). More...
static ThreadPulser | Pulser`[get]`
| Object that is used for pulsing. More...
object | TriggerLock`[get]`
| Locking object that is used for waiting trigging pulses that cause to check contition. Comes from Pulser. More...
virtual string | Path`[get, set]`
| Get or set path of the file on which the particular event is waited for. More...
bool | EnableRaisingEvents`[get, set]`
| If true, events are raised by file system watched, otherwise events are not raised. This flag can not be set when in the stage of waiting. Attpmpt of doing so has no effect (also does not throw an exception). More...
Properties inherited from IG.Lib.WaitConditionBase
object | Lock`[get]`
| This object's central lock object to be used by other object. Do not use this object for locking in class' methods, for this you should use InternalLock. More...
object | InternalLock`[get]`
| Used internally for locking access to internal fields. More...
object | WaitLock`[get]`
| Must be used only for locking waiting the Waiting() block (since it is potentially time consuming). More...
virtual bool | IsWaiting`[get, protected set]`
| True if waiting for unblocking condition is currently performed, and false otherwise. Setting should only be done within the waiting function. More...
virtual bool | CancelFlag`[get, set]`
| If this flag is set then the current waiting (if one is going on) will be cancelled. More...
Properties inherited from IG.Lib.IWaitCondition
bool | IsWaiting`[get]`
| Returns true if waiting for unblocking condition is currently performed, and false otherwise. Setting should only be done within the waiting function. More...
Properties inherited from IG.Lib.ILockable
object | Lock`[get]`
Properties inherited from IG.Lib.IWaitFileEvent
string | Path`[get, set]`
| Path of the file or directory on which the particular event is waited for. Can be specified as relative path, but is internally stored as fully qualified path. More...

## Private Attributes
bool | _printNotes = false
FileSystemWatcher | _watcher = new FileSystemWatcher()

## Static Private Attributes
static ThreadPulser | _pulser = new ThreadPulser()

## Detailed Description

Base class for classes that provide blocking until a file or directory is created/removed.

$A Igor Jun10; TODO: implement non-latence vaiting (via file events)!

## Constructor & Destructor Documentation

IG.Lib.WaitFileEventBase.WaitFileEventBase | ( | string | fileOrDirectoryPath | ) |
| inline protected

## Member Function Documentation

virtual void IG.Lib.WaitFileEventBase.InitWaitFileEventBase | ( | string | fileOrDirectoryPath | ) |
| inline protected virtual

Initializes the object appropriately. Overrride this method in derived classes!

Parameters

  fileOrDirectoryPath |

Reimplemented in IG.Lib.WaitDirectoryRemoval, IG.Lib.WaitDirectoryCreation, IG.Lib.WaitFileRemoval, and IG.Lib.WaitFileCreation.

string IG.Lib.WaitFileEventBase.EventToString | ( | FileSystemEventArgs | e | ) |
| inline protected

virtual void IG.Lib.WaitFileEventBase.OnDeleted | ( | object | source,
|  | FileSystemEventArgs | e
| ) |  |
| inline protected virtual

Handles events triggered when a file or directory is deleted.

virtual void IG.Lib.WaitFileEventBase.OnCreated | ( | object | source,
|  | FileSystemEventArgs | e
| ) |  |
| inline protected virtual

Handles events triggered when a file or directory is created.

virtual void IG.Lib.WaitFileEventBase.OnChanged | ( | object | source,
|  | FileSystemEventArgs | e
| ) |  |
| inline protected virtual

Handles events triggered when a file or directory is changed.

virtual void IG.Lib.WaitFileEventBase.OnRenamed | ( | object | source,
|  | RenamedEventArgs | e
| ) |  |
| inline protected virtual

Handles events triggered when a file or directory is renamed.

void IG.Lib.WaitFileEventBase.OnError | ( | object | source,
|  | ErrorEventArgs | e
| ) |  |
| inline protected

Handles events triggered when an error occurs.

void IG.Lib.WaitFileEventBase.TriggerConditionCheck | ( |  | ) |
| inline

Triggers condition check by pulsing the object on which Wait() successively waits.

override bool IG.Lib.WaitFileEventBase.Condition | ( |  | ) |
| inline virtual

If not overridden, this condition always returns false.

Implements IG.Lib.WaitConditionBase.

Reimplemented in IG.Lib.WaitDirectoryRemoval, IG.Lib.WaitDirectoryCreation, IG.Lib.WaitFileRemoval, and IG.Lib.WaitFileCreation.

bool IG.Lib.WaitFileEventBase.ConditionInternal | ( |  | ) |
| inline protected

Wrapper around Condition() that enables control output to console.

override void IG.Lib.WaitFileEventBase.CancelOne | ( |  | ) |
| inline virtual

Cancels the current waiting for the condition (if one is going on) and unblocks the thread on which waiting was called (possibly with some latency).

Reimplemented from IG.Lib.WaitConditionBase.

override void IG.Lib.WaitFileEventBase.CancelAll | ( |  | ) |
| inline virtual

Cancel the current waiting for the condition on all threads.

Reimplemented from IG.Lib.WaitConditionBase.

void IG.Lib.WaitFileEventBase.WaitFirstEvent | ( |  | ) |
| inline

Blocks execution of the current thread until the first event is fired by the filesystem watcher. Enables raising events on the filesystem watcher, if not enabled. WARNING: This method is NOT thread safe.

virtual void IG.Lib.WaitFileEventBase.WaitEvents | ( | int | numEvents | ) |
| inline virtual

Blocks execution of the current thread until the specified number of file system events are registered by the filesystem watcher. If the specified number of events is less than 1 then blicking is done ndefinitely (or until CancelWaiting() is called on the object from another thread). Enables raising events on the filesystem watcher, if not enabled. WARNING: This method is NOT thread safe.

Referenced by IG.Lib.WaitFileEventBase.ExampleWaitEvents().

override void IG.Lib.WaitFileEventBase.Wait | ( |  | ) |
| inline virtual

Waits for condition to be fulfilled.

Implements IG.Lib.WaitConditionBase.

Reimplemented in IG.Lib.WaitDirectoryRemoval, IG.Lib.WaitDirectoryCreation, IG.Lib.WaitFileRemoval, and IG.Lib.WaitFileCreation.

override string IG.Lib.WaitFileEventBase.ToString | ( |  | ) |
| inline

static void IG.Lib.WaitFileEventBase.ExampleWaitEvents | ( | string | fileOrDirectoryPath,
|  | int | numEvents
| ) |  |
| inline static

Waits (blocks execution) until a given number of the specified file system events are registered. Basic information is printed for each event when it occurs.

References IG.Lib.WaitFileEventBase.EnableRaisingEvents, IG.Lib.WaitFileEventBase.EventWatcher, IG.Lib.WaitFileEventBase.Path, IG.Lib.WaitFileEventBase.PrintNotes, and IG.Lib.WaitFileEventBase.WaitEvents().

Referenced by IG.Script.ScriptAppBase.FileFunctionLogEvents().

static void IG.Lib.WaitFileEventBase.ExampleBlockCreateRemove | ( | string | filePath | ) |
| inline static

Monitors the specified file and successively blocks until it is created and then until it is removed. This procedure is repeated twice.

Parameters

  filePath | File whose creation and removal is monitored.

References IG.Lib.WaitFileEventLatenceBase.ExampleLatence.ExampleBlockCreateRemove().

static void IG.Lib.WaitFileEventBase.ExampleBlockCreateRemove | ( | string | filePath,
|  | int | numSwitches
| ) |  |
| inline static

Monitors the specified file and successively blocks until it is created and then until it is removed.

Parameters

  filePath | File whose creation and removal is monitored.
  numSwitches | Number of iterations (creation/removal waits).

References IG.Lib.WaitFileEventLatenceBase.ExampleLatence.ExampleBlockCreateRemove().

static void IG.Lib.WaitFileEventBase.ExampleBlockCreateRemove | ( | string | filePath,
|  | int | numSwitches,
|  | bool | waitDirectory
| ) |  |
| inline static

Monitors the specified file and successively blocks until it is created and then until it is removed.

Parameters

  filePath | File whose creation and removal is monitored.
  numSwitches | Number of iterations (creation/removal waits).
  directory | If true then creation/removal of a directory is waiting.

References IG.Lib.WaitFileEventLatenceBase.ExampleLatence.ExampleBlockCreateRemove().

static void IG.Lib.WaitFileEventBase.TestSpeedBlockCreateRemove | ( | string | filePath | ) |
| inline static

Test of speed of reaction of file/directory creation and removal blocking waits. A specified number of alternate creations and removals are perfomed in a parallel thread, with specified delay between them. In the main thread, blocking waits are performed waiting for creation/removal in an infinite loop, and it is counted how many events are captured and how many are missed.

Parameters

  filePath | File whose creation and removal is monitored.

References IG.Lib.WaitFileEventLatenceBase.ExampleLatence.TestSpeedBlockCreateRemove().

static void IG.Lib.WaitFileEventBase.TestSpeedBlockCreateRemove | ( | string | filePath,
|  | int | numSwitches,
|  | int | sleepMs
| ) |  |
| inline static

Test of speed of reaction of file/directory creation and removal blocking waits. A specified number of alternate creations and removals are perfomed in a parallel thread, with specified delay between them. In the main thread, blocking waits are performed waiting for creation/removal in an infinite loop, and it is counted how many events are captured and how many are missed.

Parameters

  filePath | File whose creation and removal is monitored.
  numSwitches | Number of iterations (creation/removal waits).
  sleepMs | Number of milliseconds to sleep between examples.

References IG.Lib.WaitFileEventLatenceBase.ExampleLatence.TestSpeedBlockCreateRemove().

static void IG.Lib.WaitFileEventBase.TestSpeedBlockCreateRemove | ( | string | filePath,
|  | int | numSwitches,
|  | int | sleepMs,
|  | bool | waitDirectory
| ) |  |
| inline static

Test of speed of reaction of file/directory creation and removal blocking waits. A specified number of alternate creations and removals are perfomed in a parallel thread, with specified delay between them. In the main thread, blocking waits are performed waiting for creation/removal in an infinite loop, and it is counted how many events are captured and how many are missed.

Parameters

  filePath | File whose creation and removal is monitored.
  numSwitches | Number of iterations (creation/removal waits).
  sleepMs | Number of milliseconds to sleep between examples.
  directory | If true then creation/removal of a directory is waiting.

References IG.Lib.WaitFileEventLatenceBase.ExampleLatence.TestSpeedBlockCreateRemove().

## Member Data Documentation

bool IG.Lib.WaitFileEventBase._printNotes = false
| private

const System.IO.NotifyFilters IG.Lib.WaitFileEventBase.NotifyFiltersAll

Initial value:
=
NotifyFilters.Attributes | NotifyFilters.CreationTime | NotifyFilters.DirectoryName |
NotifyFilters.FileName | NotifyFilters.LastAccess | NotifyFilters.LastWrite |
NotifyFilters.Security | NotifyFilters.Size

NotifyFilter enumeration that allows all kinds of events to be fired.

FileSystemWatcher IG.Lib.WaitFileEventBase._watcher = new FileSystemWatcher()
| private

bool IG.Lib.WaitFileEventBase._eventOccured = false
| protected

ThreadPulser IG.Lib.WaitFileEventBase._pulser = new ThreadPulser()
| static private

string IG.Lib.WaitFileEventBase._fileOrDirectoryPath
| protected

File or directory name.

## Property Documentation

bool IG.Lib.WaitFileEventBase.PrintNotes
| get set

If true then various events and actions will be notified by console output (for testing purposes only!).

Referenced by IG.Lib.WaitFileEventBase.ExampleWaitEvents().

FileSystemWatcher IG.Lib.WaitFileEventBase.EventWatcher
| get protected

Component that responds to file system events.

Referenced by IG.Lib.WaitFileEventBase.ExampleWaitEvents().

virtual bool IG.Lib.WaitFileEventBase.EventOccured
| get set

This flag is set by event handlers, and can be used by waiting procedures to check if the current event has been triggered by the EventWatcher installed on the other object (since registration of events of all other EventWatchers is done on the same thread).

ThreadPulser IG.Lib.WaitFileEventBase.Pulser
| static get protected

Object that is used for pulsing.

object IG.Lib.WaitFileEventBase.TriggerLock
| get protected

Locking object that is used for waiting trigging pulses that cause to check contition. Comes from Pulser.

virtual string IG.Lib.WaitFileEventBase.Path
| get set

Get or set path of the file on which the particular event is waited for.

Referenced by IG.Lib.WaitFileEventBase.ExampleWaitEvents().

bool IG.Lib.WaitFileEventBase.EnableRaisingEvents
| get set

If true, events are raised by file system watched, otherwise events are not raised. This flag can not be set when in the stage of waiting. Attpmpt of doing so has no effect (also does not throw an exception).

Referenced by IG.Lib.WaitFileEventBase.ExampleWaitEvents().

The documentation for this class was generated from the following file:

- igbase/0unsorted/WaitConditionFile.cs